#!/bin/bash 
# projectid: 50380
# name: PATCH-X86-THIRD-1.1.4.sh
# date: 2023/10/16

ret_success=0
ret_success_restart=1
ret_success_reboot=2
ret_fail_roolback=6
ret_fail_others=7
script_name=$(basename $0)

log_exit() 
{
    echo `date` "$script_name upgrade: ${1} exit $2" 
    exit ${2}
}

rpm_check_bind()
{
    newVersion=$2
    currentVersion=$(rpm -qa $1)

    if [ -z "$currentVersion" ];then
        return 1;
    fi
    
    if [[ "${currentVersion}" == "${newVersion}" ]];then
        echo "RPM package is already up to date !!! current${1}Version:${currentVersion}---target_version:${newVersion}"
        return 0
    else
        version=$(rpm -q --qf '%{VERSION}-%{RELEASE}' "${currentVersion}")
        tarversion2=$(echo "$newVersion" | grep -oE '[0-9]+\.[0-9]+\.[0-9]+-[0-9A-Za-z._-]+')
        tarversion2=$(echo "$tarversion2" | sed 's/\.x86_64$//')
        if [[ $(echo "$tarversion2 $version" | tr " " "\n" | sort -V | tail -n 1) == $tarversion2 ]];then
            echo "current${1}Version:${version}  less than target_version:${tarversion2},updating"
            return 1
        fi
    fi
}

check_error_and_exit()
{
    if [ ! $1 -eq 0 ];then
        echo "$2"
        exit  7
    fi
}

update_bind()
{
    currentDir=/etc/cpeagent/upgrade/PATCH-X86-THIRD-1.1.4

    rpm_check_bind  bind-libs bind-libs-9.11.4-26.P2.el7_9.14.x86_64
    if [ $? -eq 1 ]
    then
        rpm -Uvh --replacepkgs ${currentDir}/package/*

        check_error_and_exit $? "bind install failed!"
        echo "###################################################################"
        echo "bind install success!"
        echo "###################################################################"

    fi
    return 0
}

install()
{
    update_bind
}

uninstall()
{
    exit $ret_success
}

if [ "$1" == "install" ];then
    install
elif [ "$1" == "uninstall" ]; then
    uninstall
else
    log_exit "invalid args" $ret_fail_others
fi

